#ifndef DNS_H
#define DNS_H
//////////////////////////////////////////////////////////////////////////////
// dns.h: header file for direct numerical simulation solver.
//
// Copyright (c) 1994 <--> $Date: 2013/10/21 17:27:42 $, Hugh Blackburn
//
// $Id: dns.h,v 7.4 2013/10/21 17:27:42 hmb Exp $
//////////////////////////////////////////////////////////////////////////////

#include <sem.h>


class DNSAnalyser : public Analyser
// ===========================================================================
// Implement step-by-step processing and output control for flow solver.
// ===========================================================================
{
public:
  DNSAnalyser  (Domain*, BCmgr*, FEML*);
  void analyse (AuxField**, AuxField**);

private:
  ofstream       _flx_strm;

  bool           _wss; // -- Shorthand for Wall Shear Stress/traction.
  ofstream       _wss_strm;
  int_t          _nline;
  int_t          _nwall;
  int_t          _npad;
  
  vector<real_t> _work;

  void extract_wall ();
};

void skewSymmetric    (Domain*, AuxField**, AuxField**, vector<real_t>&);
void altSkewSymmetric (Domain*, AuxField**, AuxField**, vector<real_t>&);
void convective       (Domain*, AuxField**, AuxField**, vector<real_t>&);
void Stokes           (Domain*, AuxField**, AuxField**, vector<real_t>&);

#endif
